# MAIN IMPORTS ================================================================================================================================================ #
import es
import keyvalues
import os
import playerlib
import popuplib
import time
import psyco
import langlib
psyco.full()
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')
bans   = es.import_addon('sam/base/pcontrol/ban')

# VARIABLES

# '''''''''''''''''''' # Lang Strings # '''''''''''''''''''' #
langDir     = es.getAddonPath('sam') + '/langs/'
commonText  = langlib.Strings(langDir + 'common.ini')
adminsText  = langlib.Strings(langDir + 'admins/admins.ini')
popupText   = langlib.Strings(langDir + 'pcontrol/popups.ini')
actionsText = langlib.Strings(langDir + 'pcontrol/actions.ini')
hudtag      = 'ADMINS ::'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

temp = {}

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' POPUPS '''
	func.popupDelete('banList')
	func.popupDelete('banPage')
	
# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid):
	temp[userid] = {}
	if os.path.isfile(bans.db_dir):
		kg    = keyvalues.getKeyGroup(bans.db)
		tlist = []
		for item in kg: tlist.append(item)
		if len(tlist) >= 1:
			func.popupDelete('banList')
			popup = popuplib.easymenu('banList', None, banPage)
			popup.c_beginsep = '-' * 45
			popup.c_pagesep  = '-' * 45
			popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
			popup.setdescription('\n \n :: ' + popupText('unbanDesc', None, func.getLang()))
			banned = []
			for ban in kg:
				if bans.isBanned(ban): banned.append(ban)
			if len(banned) > 0:
				for ban in banned:
					player = bans.getBanned(ban)
					popup.addoption(item, '%s [%s]' % (player['name'], popupText(player['length'], None, func.getLang())))
				popup.submenu(10, 'pcontrol')
				popup.send(userid)
			else:
				func.hudhint(userid, actionsText('noBannedPlayers', None, func.getLang()), hudtag)
				sendMenu(userid, 'pcontrol')
		else:
			func.hudhint(userid, actionsText('noBannedPlayers', None, func.getLang()), hudtag)
			sendMenu(userid, 'pcontrol')
	else:
		func.hudhint(userid, actionsText('noBannedPlayers', None, func.getLang()), hudtag)
		sendMenu(userid, 'pcontrol')

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def banPage(userid, choice, popup):
	temp[userid]['target'] = choice
	player = bans.getBanned(choice)

	if player['length'] == 'perm': string = ' # %s: %s' % (func.commonText('length', None, func.getLang()),func.commonText('perm', None, func.getLang()))
	else: string = ' # %s: %s' % (func.commonText('length', None, func.getLang()),popupText(player['length'], None, func.getLang()))

	func.popupDelete('banPage')
	popup = popuplib.create('banPage')
	popup.addline('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.addline('\n \n :: ' + popupText('unbanTitle', None, func.getLang()))
	popup.addline('-' * 45)
	popup.addline(' # %s: %s' % (func.commonText('name', None, func.getLang()),player['name']))
	popup.addline(' # ID: %s' % (player['steamid']))
	popup.addline(string)
	popup.addline(' # Ban userid: %s' % player['admin'])
	popup.addline(' # %s: %s' % (func.commonText('reason', None, func.getLang()),player['reason']))
	popup.addline(' \n' + popupText('confirmUnban', None, func.getLang()))
	popup.addline('->1. %s' % func.commonText('yes', None, func.getLang()))
	popup.addline('->2. %s' % func.commonText('no', None, func.getLang()))
	popup.addline('-' * 45)
	popup.addline('0. ' + func.commonText('cancel', None, func.getLang()))
	popup.menuselect = banPageChoice
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def banPageChoice(userid, choice, popup):
	func.popupDelete('banPage')
	if choice == 1:
		if userid in temp and len(temp[userid]) == 1:
			func.hudhint(userid, actionsText('unbanned', bans.getBanned(temp[userid]['target']), func.getLang()), hudtag)
			es.keydelete(bans.db, temp[userid]['target'])
			es.keygroupsave(bans.db, func.default.dbfiles)
			del temp[userid]
	elif choice == 2: moduleAction(userid)

# ============================================================================================================================================================= #
